

    This code is a simple modification of the example provided in the Java Tutorial form Sun. The only
    thing to modify is the text to submit when do you want to make a POST or a GET: 

    Steps to make the submission: 

    POST METHOD:

      1.Create the URL to the server CGI 
      2.Open the connection 
      3.Open type outputstream 
      4.Create the output string with the format: varname1=varvalue1&varname2=varvalue2 // and so on
        Note that the character '&' is the separator from variables. 
      5.Close the outputstream 
      6.Open the input stream 
      7.Read the response from the server 
      8.Close the input stream. 

    GET METHOD: 

      1.Create the URL to the server CGI with the diference: Example: 

                         'www.pp.com/pp.cgi?'+the output string with the 
                                              self format form the output
                                              string like the step 4 in the 
                                              POST METHOD.

      2.Open the connection 
      3.Open the input stream 
      4.Read the response from the server 
      5.Close the input stream. 

    Note: The GET method does not requires an outputstream. 

    The following example is to submit a form with the POST method, I have tried with a lot of forms and it
    works well. 

    import java.io.*;
    import java.net.*;

    public class TestingTheForm {

     public static void main(String[] args) {
       try {
        URL url = new URL("TheURL");
        System.err.println("URL created:" + url.toString());

        URLConnection connection = url.openConnection();
        System.err.println("URLConnection opened ...");
                                                    
        PrintStream outStream = new
        PrintStream(connection.getOutputStream());
        System.err.println("outStream created ...");

        outStream.println("var1=value1&var2=value2&var3=value3");
        System.err.println("the data printed ...");
        outStream.close();
        System.err.println("outStream closed ...");

                            
        DataInputStream inStream = new
        DataInputStream(connection.getInputStream());
        String inputLine;
        System.err.println("inStream opened ...");
                            
        while ((inputLine = inStream.readLine()) != null) {
            System.out.println(inputLine);
        }
        inStream.close();
        System.err.println("inStream closed ...");
                    
      } catch (MalformedURLException me) {
         System.err.println("MalformedURLException: " + me);
      } catch (IOException ioe) {
         System.err.println("IOException: " + ioe);
      }
    }
            
    }

(Submitted by Jean-Luc DELATRE) 

    You don't need to mess around with sockets and the HTTP header to issue a POST you just need to
    provide the "Content-type" and "Content-length" this is an excerpt from a working applet of mine
    which can be seen at http://www.lga.jca.fr/dossier_web/jld/accueilcafe.html (all in french, sorry...) this
    however does NOT solve the long outstanding showDocument() problem (see
    http://www.tientien.com/tjn/post/index.html) which is the last question in your "CGI, Servers" 

    {
            .../...
                            
            if (! usePOST)
            {
                    cgiUrl = new URL(getDocumentBase(), "cgi/bounce.cgi" + query);
            debugOut("translated url: " + cgiUrl.toExternalForm());
                    connect = cgiUrl.openConnection();
            }
            else
            {
                    cgiUrl = new URL(getDocumentBase(), "cgi/bounce.cgi");
            debugOut("translated url: " + cgiUrl.toExternalForm());
                    connect = cgiUrl.openConnection();
            connect.setDoInput(true);
            connect.setDoOutput(true);
            connect.setUseCaches(false);
                    connect.setRequestProperty ("Content-type",
                            "application/dont-know-what");

            String request = "nom=" +  name.getText() + " "
                               + "email=" +  email.getText() + " "
                               + "options=" + options.getSelectedItem() + " "
                               + "\r\n";
                                                            
                    connect.setRequestProperty ("Content-length",
                            Integer.toString(request.length()));

            outStream = new DataOutputStream(connect.getOutputStream());
                            
            outStream.writeBytes(request);
            }

            DataInputStream inStream = new
                    DataInputStream(connect.getInputStream());

            debugOut("Content " + connect.getContentType() +
                                    " length "
                                    + Integer.toString(connect.getContentLength()));

            while ((inputLine = inStream.readLine()) != null) {
                    debugOut(inputLine);
            }
                    
            if (usePOST) outStream.close();
            inStream.close();
    }

(Submitted by Dennis M. Kowallek) 

    The following is from a POST on "comp.lang.java" by Ronald.Tschalaer@psi.ch. I tried it and it works! 

    This is probably more an http question, but basically all you need to do is create a header of the form: 

      POST cgi-script HTTP/1.0
      Content-type: 
      Content-length: 
      
      The data you're posting...

    Here is a simple java applet which will contact my_script.cgi, post it the stuff in sdata, and read in the
    reply into rdata and display it. 

    PostExample.java:
    -----------------

    import java.applet.Applet;
    import java.awt.*;
    import java.net.*;
    import java.io.*;
    import java.util.*;

    public class PostExample extends Applet
    {
        private final String script = "/cgi-bin/my_script.cgi";
        private final String ctype  = "application/octet-stream";
        // note: on some servers this needs to be "application/x-www-form-urlencoded"
        // - Courtesy, John Fallows
        private       String sdata  = "Hello World";
        private       String rdata  = "";
        private       String home;
        private       int    port;

        public void init()
        {
            home = getDocumentBase().getHost();
            port = getDocumentBase().getPort();
            if (port == -1)  port = 80;
        }

        public void start()
        {
            Socket           sock;
            OutputStream     outp;
            InputStream      inp;
            DataOutputStream dataout;
            DataInputStream  datain;

            rdata = "";

            //create a client socket 

            try
                sock = new Socket(home, port);
            catch (Exception e)
            {
                rdata = e+" (socket: Host: "+home+"\tPort: "+port+")";
                return;
            }

            // Obtain output stream to communicate with the server

            try
            {
                outp = sock.getOutputStream();
                inp  = sock.getInputStream();
            }
            catch (Exception e)
            {
                rdata = e+" (getstream)";
                try
                    sock.close();
                catch (IOException ee) ;
                return;
            }    

            try
            {
                dataout = new DataOutputStream(outp);
                datain  = new DataInputStream(inp);
            }
            catch (Exception e)
            {
                rdata = e+" (Dstream)";
                try
                    sock.close();
                catch (IOException ee) ;
                return;
            }

            // Send http request to server and get return data

            try
            {
                // HTTP header
                dataout.writeBytes("POST " + script + " HTTP/1.0\r\n");
                dataout.writeBytes("Content-type: " + ctype + "\r\n");
                dataout.writeBytes("Content-length: " + sdata.length() + "\r\n");
                dataout.writeBytes("\r\n");         // end of header
                // POST data
                dataout.writeBytes(sdata);
                            dataout.writeBytes("\r\n");
                boolean body = false;
                String line;
                while ((line = datain.readLine()) != null)
                {
                    if (body)
                        rdata += "\n" + line;
                    else if (line.equals(""))       // end of header
                        body = true;
                }
            }
            catch (Exception e)
            {
                rdata = e+" (write)";
                try
                    sock.close();
                catch (IOException ee) ;
                return;
            }

            // close up shop

            try
            {
                dataout.close();
                datain.close();
            }
            catch (IOException e) ;
            try
                sock.close();
            catch (IOException e) ;
        }

        public void stop() {}

        public void paint(Graphics g)
        {
            StringTokenizer st = new StringTokenizer(rdata, "\n");
            int line    = 1,
                line_sp = getFontMetrics(getFont()).getHeight()+1;
     
            while (st.hasMoreTokens())
            {
                g.drawString(st.nextToken(), 5, line*line_sp);
                line++;
            }
        }
    }

(Submitted by Luc Snels)  

    If you use the previous method with 16-bit char data (i.e. the upper 8 bits of a char are not zero) sustitute
    your "dataout.writeBytes()" with this "sendString()" method: 

    void sendString(String x){
            byte bytes[]=new byte[x.length()];
            x.getBytes(0,x.length(),bytes,0);
            try for (int i=0; i < x.length(); i++)
                    dataout.writeByte(bytes[i]);
            catch(Exception e);
    }

A related question... 

    "Also, whenever I run a CGI script that generates a document, no applets run from that document,
    presumably because the document directory changes, but I see no way of changing it back..." 

    Just make sure the CODEBASE attribute in the APPLET tag points to the directory in which the applet
    sits, then it works fine (either use an absolute path, or remember that the path will be relative to the
    directory the cgi-script resides in (usually /cgi-bin) ). - Ronals McNulty 
